#PBFORMS Created
#COMPILE EXE
#DIM ALL
#REGISTER NONE
#RESOURCE "pcw.pbr"

'Dieses Programm ist freie Software. Sie knnen es unter
'den Bedingungen der GNU General Public License, wie von der
'Free Software Foundation herausgegeben, weitergeben und/oder
'modifizieren, entweder unter Version 2 der Lizenz oder (wenn
'Sie es wnschen) jeder spteren Version

'Autor: Christian Lbering
'Firma: IDG Magazine GmbH
'Email: prx@pcwelt.de
'Datum: 01/2006
'Version: 1.0.0

'Infos: Kompiliert mit Powerbasic 7

'--------------------------------------------------------------------------------
'   ** Includes **
'--------------------------------------------------------------------------------
#PBFORMS Begin Includes
#IF NOT %DEF(%WINAPI)
    #INCLUDE "WIN32API.INC"
#ENDIF
#IF NOT %DEF(%COMMCTRL_INC)
    #INCLUDE "COMMCTRL.INC"
#ENDIF
#INCLUDE "PBForms.INC"
#PBFORMS End Includes
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Dialog-Konstanten **
'--------------------------------------------------------------------------------
#PBFORMS Begin Constants
%IDD_DIALOG1                = 101
%IDC_MSCTLS_PROGRESS32_1    = 1001
%IDC_LABEL1                 = 1002
%IDC_Hives                  = 1002
%IDC_Pfad                   = 1003
%IDC_Browse                 = 1004
%IDC_Save                   = 1005
%IDC_Restore                = 1006
%IDC_Date                   = 1007
%IDC_Quit                   = 1008
%IDC_IMAGEX1                = 1009
%IDC_ZP                     = 1010
%IDR_IMGFILE1               = 102
#PBFORMS End Constants
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   **  Funktions-Deklarationen **
'--------------------------------------------------------------------------------
GLOBAL MainKeyHandle AS LONG
DECLARE CALLBACK FUNCTION ShowDIALOG1Proc()
DECLARE FUNCTION SampleProgress(BYVAL hDlg AS DWORD, BYVAL lID AS LONG, n AS LONG) AS LONG
DECLARE FUNCTION ShowDIALOG1(BYVAL hParent AS DWORD) AS LONG
DECLARE FUNCTION DoesFileExist(BYVAL sFileName AS STRING) AS INTEGER
DECLARE FUNCTION RemoveFile (BYVAL File AS STRING) AS INTEGER
DECLARE FUNCTION EnableBackupPriv AS LONG
DECLARE FUNCTION EnableRestorePriv AS LONG
DECLARE FUNCTION EnableOwnerPriv AS LONG
DECLARE FUNCTION EnableDebugPriv AS LONG
DECLARE FUNCTION BackupReg(SubKeyIn AS STRING, OutFile AS STRING) AS LONG
DECLARE FUNCTION RestoreReg(SubKeyIn AS STRING, InFile AS STRING, OldFile AS STRING) AS LONG
DECLARE FUNCTION ParseKey(Keyname AS STRING, Keyhandle AS LONG) AS LONG
DECLARE FUNCTION GetMainKeyHandle(MainKeyName AS STRING) AS LONG
DECLARE FUNCTION GetFolderDlg(hlg AS LONG) AS STRING
DECLARE FUNCTION RegSaveKeyEx ALIAS "RegSaveKeyExA" (BYVAL hKey AS DWORD, lpFile AS ASCIIZ, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwFlags AS DWORD) AS LONG

#PBFORMS Declarations
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   **  Haupt-Funktion **
'--------------------------------------------------------------------------------
FUNCTION PBMAIN()
    PBFormsInitComCtls (%ICC_WIN95_CLASSES OR %ICC_DATE_CLASSES OR %ICC_INTERNET_CLASSES)
    ShowDIALOG1 %HWND_DESKTOP
END FUNCTION

'--------------------------------------------------------------------------------
'   **  Funktion zur berprfung ob eine Datei oder ein Ordner existiert **
'--------------------------------------------------------------------------------
FUNCTION DoesFileExist(BYVAL sFileName AS STRING) AS INTEGER
DIM nErr AS LONG
DIM zFileName AS ASCIIZ*(%MAX_PATH + 1)
zFileName=sFileName
nErr=GetFileAttributes(zFileName)
IF nErr = -1 THEN
    FUNCTION = %FALSE
ELSE
    FUNCTION = %TRUE
END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum lschen einer Datei falls sie existiert **
'--------------------------------------------------------------------------------
FUNCTION RemoveFile (BYVAL File AS STRING) AS INTEGER
ON ERROR GOTO RemoveError
IF DoesFileExist(File)=%TRUE THEN
    SETATTR File, %ATTR_NORMAL
    KILL File
    FUNCTION=0
ELSE
    FUNCTION=53 'File not found
END IF
ON ERROR GOTO 0
EXIT FUNCTION
RemoveError:
FUNCTION = ERRCLEAR
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum Setzen der Backup-Privilegien **
'--------------------------------------------------------------------------------
FUNCTION EnableBackupPriv AS LONG
    LOCAL hTokenHandle AS LONG
    LOCAL sebackupnameValue AS Luid
    LOCAL tkp AS TOKEN_PRIVILEGES
    LOCAL i AS LONG
    IF OpenProcessToken(GetCurrentProcess, %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hTokenHandle) THEN
        IF LookupPrivilegeValue("", $SE_BACKUP_NAME, BYVAL VARPTR(sebackupnameValue)) THEN
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
            tkp.Privileges(0).pLuid = sebackupnameValue
            IF AdjustTokenPrivileges(hTokenHandle, %False, tkp, SIZEOF(tkp), BYVAL 0, BYVAL 0) THEN FUNCTION = 1
        END IF
        CloseHandle hTokenHandle
    END IF
END FUNCTION

'--------------------------------------------------------------------------------
'   **  Funktion zum Setzen der Restore-Privilegien **
'--------------------------------------------------------------------------------
FUNCTION EnableRestorePriv AS LONG
    LOCAL hTokenHandle AS LONG
    LOCAL serestorenameValue AS Luid
    LOCAL tkp AS TOKEN_PRIVILEGES
    LOCAL i AS LONG
    IF OpenProcessToken(GetCurrentProcess, %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hTokenHandle) THEN
        IF LookupPrivilegeValue("", $SE_RESTORE_NAME, BYVAL VARPTR(SerestorenameValue)) THEN
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
            tkp.Privileges(0).pLuid = serestorenameValue
            IF AdjustTokenPrivileges(hTokenHandle, %False, tkp, SIZEOF(tkp), BYVAL 0, BYVAL 0) THEN FUNCTION = 1
        END IF
        CloseHandle hTokenHandle
    END IF
END FUNCTION

'--------------------------------------------------------------------------------
'   **  Funktion zum Setzen der Debug-Privilegien **
'--------------------------------------------------------------------------------
FUNCTION EnableDebugPriv AS LONG
    LOCAL hTokenHandle AS LONG
    LOCAL sedebugnameValue AS Luid
    LOCAL tkp AS TOKEN_PRIVILEGES
    LOCAL i AS LONG
    IF OpenProcessToken(GetCurrentProcess, %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hTokenHandle) THEN
        IF LookupPrivilegeValue("", $SE_DEBUG_NAME, BYVAL VARPTR(SedebugnameValue)) THEN
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
            tkp.Privileges(0).pLuid = sedebugnameValue
            IF AdjustTokenPrivileges(hTokenHandle, %False, tkp, SIZEOF(tkp), BYVAL 0, BYVAL 0) THEN FUNCTION = 1
        END IF
        CloseHandle hTokenHandle
    END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum Setzen der Besitzer-Privilegien **
'--------------------------------------------------------------------------------
FUNCTION EnableOwnerPriv AS LONG
    LOCAL hTokenHandle AS LONG
    LOCAL seownerenameValue AS Luid
    LOCAL tkp AS TOKEN_PRIVILEGES
    LOCAL i AS LONG
    IF OpenProcessToken(GetCurrentProcess, %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hTokenHandle) THEN
        IF LookupPrivilegeValue("", $SE_TAKE_OWNERSHIP_NAME, BYVAL VARPTR(seownerenameValue)) THEN
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
            tkp.Privileges(0).pLuid = seownerenameValue
            IF AdjustTokenPrivileges(hTokenHandle, %False, tkp, SIZEOF(tkp), BYVAL 0, BYVAL 0) THEN FUNCTION = 1
        END IF
        CloseHandle hTokenHandle
    END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum Setzen der Shutdown-Privilegien **
'--------------------------------------------------------------------------------
FUNCTION EnableShutdownPriv AS LONG
    LOCAL hTokenHandle AS LONG
    LOCAL seShutdownnameValue AS Luid
    LOCAL tkp AS TOKEN_PRIVILEGES
    LOCAL i AS LONG
    IF OpenProcessToken(GetCurrentProcess, %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hTokenHandle) THEN
        IF LookupPrivilegeValue("", $SE_SHUTDOWN_NAME, BYVAL VARPTR(seShutdownnameValue)) THEN
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
            tkp.Privileges(0).pLuid = seShutdownnameValue
            IF AdjustTokenPrivileges(hTokenHandle, %False, tkp, SIZEOF(tkp), BYVAL 0, BYVAL 0) THEN FUNCTION = 1
        END IF
        CloseHandle hTokenHandle
    END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum Parsen eines Registry-Schlssels **
'--------------------------------------------------------------------------------
FUNCTION ParseKey(Keyname AS STRING, Keyhandle AS LONG) AS LONG
DIM rtnKey AS LONG
rtnKey = INSTR(Keyname, "\")
IF LEFT$(Keyname, 5) <> "HKEY_" OR RIGHT$(Keyname, 1) = "\" THEN
    MSGBOX "Falsches Format:" + CHR$(10) + CHR$(10) + Keyname,, "Schlssel-Parser"
    EXIT FUNCTION
ELSEIF rtnKey = 0 THEN
    Keyhandle = GetMainKeyHandle(Keyname)
    Keyname = ""
ELSE
    Keyhandle = GetMainKeyHandle(LEFT$(Keyname, rtnKey - 1))
    Keyname = RIGHT$(Keyname, LEN(Keyname) - rtnKey)
END IF

END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum Ermitteln des Haupt-Hives eines Registry-Schlssels **
'--------------------------------------------------------------------------------
FUNCTION GetMainKeyHandle(MainKeyName AS STRING) AS LONG

DIM HKEY_CLASSES_ROOT AS LONG
DIM HKEY_CURRENT_USER AS LONG
DIM HKEY_LOCAL_MACHINE AS LONG
DIM HKEY_USERS AS LONG
DIM HKEY_PERFORMANCE_DATA AS LONG
DIM HKEY_CURRENT_CONFIG AS LONG
DIM HKEY_DYN_DATA AS LONG

HKEY_CLASSES_ROOT = &H80000000
HKEY_CURRENT_USER = &H80000001
HKEY_LOCAL_MACHINE = &H80000002
HKEY_USERS = &H80000003
HKEY_PERFORMANCE_DATA = &H80000004
HKEY_CURRENT_CONFIG = &H80000005
HKEY_DYN_DATA = &H80000006

SELECT CASE MainKeyName
CASE "HKEY_CLASSES_ROOT"
GetMainKeyHandle = HKEY_CLASSES_ROOT
CASE "HKEY_CURRENT_USER"
GetMainKeyHandle = HKEY_CURRENT_USER
CASE "HKEY_LOCAL_MACHINE"
GetMainKeyHandle = HKEY_LOCAL_MACHINE
CASE "HKEY_USERS"
GetMainKeyHandle = HKEY_USERS
CASE "HKEY_PERFORMANCE_DATA"
GetMainKeyHandle = HKEY_PERFORMANCE_DATA
CASE "HKEY_CURRENT_CONFIG"
GetMainKeyHandle = HKEY_CURRENT_CONFIG
CASE "HKEY_DYN_DATA"
GetMainKeyHandle = HKEY_DYN_DATA
END SELECT

END FUNCTION

'--------------------------------------------------------------------------------
'   **  Funktion zum sichern eines Registry-Schlssels in eine Datei **
'--------------------------------------------------------------------------------
FUNCTION BackupReg(SubKeyIn AS STRING, OutFile AS STRING) AS LONG
DIM rtnKey AS LONG
DIM rtn AS LONG
DIM SubKey AS STRING
DIM SubKeyz AS ASCIIZ * 256
DIM sBufferz AS ASCIIZ * 256
DIM lBufferSize AS LONG
DIM LpFile AS ASCIIZ * 256
DIM hKey AS DWORD
DIM lpSecurityAttributes AS SECURITY_ATTRIBUTES
DIM fl AS DWORD
DIM hLib AS LONG
DIM hProc AS LONG

SubKey=SubKeyIn
rtn = ParseKey(SubKey, MainKeyHandle)
SubKeyz=SubKey
LpFile=OutFile
rtn = EnableBackupPriv
rtn = EnableOwnerPriv
rtn = EnableDebugPriv
IF MainKeyHandle THEN
    rtn = RegCreateKeyEx(MainKeyHandle,SubKeyz,0,"", %REG_OPTION_BACKUP_RESTORE, %KEY_ALL_ACCESS, BYVAL 0, hKey, 0)
    IF rtn = %ERROR_SUCCESS THEN
        lBufferSize = 256
        hLib = LoadLibrary("ADVAPI32.DLL")
        hProc = GetProcAddress(hLib,"RegSaveKeyExA")
        IF ISFALSE(hProc) THEN
            CALL RegSaveKey(hKey, LpFile, BYVAL 0) TO rtnKey
            IF rtnkey = %ERROR_SUCCESS THEN
                rtnKey = RegCloseKey(hKey)
                FUNCTION = %ERROR_SUCCESS
            ELSE
                rtnKey = RegCloseKey(hKey)
                KILL Outfile
                MSGBOX "Fehlernummer: " & STR$(rtnkey) & " in Datei " & Outfile, %MB_OK + %MB_ICONWARNING, "Fehler in RegSaveKey"
                FUNCTION = rtnKey
            END IF
        ELSE
            CALL DWORD hProc USING RegSaveKeyEx(hKey, LpFile, BYVAL 0, BYCOPY 4) TO rtnKey
            IF rtnKey = %ERROR_SUCCESS THEN
                rtnKey = RegCloseKey(hKey)
                FUNCTION = %ERROR_SUCCESS
            ELSE
                KILL Outfile
                CALL RegSaveKey(hKey, LpFile, BYVAL 0) TO rtnKey
                IF rtnkey = %ERROR_SUCCESS THEN
                    rtnKey = RegCloseKey(hKey)
                    FUNCTION = %ERROR_SUCCESS
                ELSE
                    KILL Outfile
                    rtnKey = RegCloseKey(hKey)
                    KILL Outfile
                    MSGBOX "Fehlernummer: " & STR$(rtnkey) & " in Datei " & Outfile, %MB_OK + %MB_ICONWARNING, "Fehler in RegSaveKey"
                    FUNCTION = rtnKey
                END IF
            END IF
        END IF
    ELSE
        MSGBOX "Fehlernummer: " & STR$(rtnkey) & " in Datei " & Outfile, %MB_OK + %MB_ICONWARNING, "Fehler in RegCreateKeyEx"
        FUNCTION = -1
    END IF
END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zum Wiederherstellen eines Registry-Schlssels aus einer Datei **
'--------------------------------------------------------------------------------
FUNCTION RestoreReg(SubKeyIn AS STRING, InFile AS STRING, OldFile AS STRING) AS LONG
LOCAL rtnKey AS LONG
LOCAL SubKey AS STRING
LOCAL SubKeyz AS ASCIIZ * 255
LOCAL sBufferz AS ASCIIZ * 255
LOCAL LpFile AS ASCIIZ * 255
LOCAL OldFilez AS ASCIIZ * 255
LOCAL rtn AS LONG
LOCAL hhKey AS DWORD
LOCAL wdconf AS STRING
LOCAL n AS LONG

n = 0
wdconf = ENVIRON$("systemroot") & "\System32\config"

SubKey=SubKeyIn
rtn = ParseKey(SubKey, MainKeyHandle)
SubKeyz=SubKey
Oldfilez = wdconf & "\" & OldFile
LpFile=wdconf & "\" & InFile
IF DoesFileExist(wdconf & "\" & oldfile) = %true THEN
    KILL wdconf & "\" & oldfile
END IF
rtn = EnableBackupPriv
rtn = EnableRestorePriv
rtn = EnableOwnerPriv
rtn = EnableDebugPriv
IF MainKeyHandle THEN
    rtn = RegCreateKeyEx(MainKeyHandle,SubKeyz,0,"", %REG_OPTION_BACKUP_RESTORE, %KEY_ALL_ACCESS, BYVAL 0, hhKey, 0)
    IF rtn = %ERROR_SUCCESS THEN
        CALL RegReplaceKey(hhKey, SubKeyz, LpFile, Oldfilez) TO rtnKey
        IF NOT rtnKey = %ERROR_SUCCESS THEN
            MSGBOX "Fehlernummer: " & STR$(rtnkey) & " in Datei " & lpfile & $CRLF & $CRLF & "Stellen Sie Ihre Registry bitte " & _
            "in der Wiederherstellungskonsole ber die Batchdatei ConsoleBackup.BAT aus dem Backup-Verzeichnis wieder her.", %MB_OK + %MB_ICONWARNING, "Fehler in RegReplaceKey"
        END IF
        rtnKey = RegCloseKey(hhKey)
        FUNCTION=rtnKey
    ELSE
        MSGBOX "Fehlernummer: " & STR$(rtnkey) & " in Datei " & Infile, %MB_OK + %MB_ICONWARNING, "Fehler in RegCreateKeyEx"
        FUNCTION = -1
    END IF
ELSE
    FUNCTION=-99999
END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zur Auszhlung und Sicherung aller Registry-Hives **
'--------------------------------------------------------------------------------
FUNCTION BakEnumKeys(hdlg AS LONG) AS LONG
LOCAL pfad AS STRING
LOCAL x AS LONG
LOCAL hkey AS LONG
LOCAL cnt AS LONG
LOCAL XX AS LONG
LOCAL n AS LONG
LOCAL Value AS STRING
LOCAL Valuez AS ASCIIZ * 256
LOCAL Subkeyz AS ASCIIZ * 256
LOCAL Subkey AS STRING
LOCAL sbuffer AS ASCIIZ * 256
LOCAL datesub AS LONG
LOCAL hkey1 AS LONG
LOCAL rval AS DWORD

CONTROL DISABLE hDlg, %IDC_Save
CONTROL DISABLE hDlg, %IDC_Restore
CONTROL DISABLE hDlg, %IDC_Quit
CONTROL DISABLE hDlg, %IDC_Browse

CONTROL GET TEXT hDlg, %IDC_Pfad TO pfad

x = DoesFileExist(Pfad)
IF X = %false THEN
    MKDIR pfad
END IF
SampleProgress hDlg, %IDC_MSCTLS_PROGRESS32_1, 1

rval = 1
X = RegOpenKeyEx(%HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Setup\RecoveryConsole", 0&, %KEY_ALL_ACCESS, hKey1)
X = RegSetValueEx(hkey1, "SetCommand", 0, %REG_DWORD, rval, 4)
x = RegCloseKey(hkey1)

OPEN pfad & "\ConsoleBackup.bat" FOR OUTPUT AS #1
PRINT #1, "Set allowallpaths = true"

CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SOFTWARE"
X = DoesFileExist(pfad & "\SOFTWARE")
IF x = %true THEN
    X = RemoveFile(pfad &"\SOFTWARE")
END IF
X = BackupReg("HKEY_LOCAL_MACHINE\SOFTWARE", pfad & "\SOFTWARE")
PRINT #1, "copy " CHR$(34) & pfad & "\SOFTWARE" & CHR$(34) & " " & ENVIRON$("systemroot") & "\System32\config\"
X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 10)

CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SYSTEM"
X=DoesFileExist(pfad &"\SYSTEM")
IF x = %true THEN
    X = RemoveFile(pfad & "\SYSTEM")
END IF
X = BackupReg("HKEY_LOCAL_MACHINE\SYSTEM", pfad & "\SYSTEM")
PRINT #1, "copy " CHR$(34) & pfad & "\SYSTEM" & CHR$(34) & " " & ENVIRON$("systemroot") & "\System32\config\"
X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 20)

CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SECURITY"
X = DoesFileExist(pfad &"\SECURITY")
IF x = %true THEN
    X=RemoveFile(pfad &"\SECURITY")
END IF

X = BackupReg("HKEY_LOCAL_MACHINE\SECURITY", pfad & "\SECURITY")
PRINT #1, "copy " CHR$(34) & pfad & "\SECURITY" & CHR$(34) & " " & ENVIRON$("systemroot") & "\System32\config\"
X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 30)

CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SAM"
X = DoesFileExist(pfad &"\SAM")
IF x = %true THEN
    X = RemoveFile(pfad &"\SAM")
END IF
X = BackupReg("HKEY_LOCAL_MACHINE\SAM", pfad & "\SAM")
PRINT #1, "copy " CHR$(34) & pfad & "\SAM" & CHR$(34) & " " & ENVIRON$("systemroot") & "\System32\config\"
X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 40)

SubKey = "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\hivelist"
X = ParseKey(SubKey, MainKeyHandle)
SubKeyz=SubKey
X = RegOpenKeyEx(MainKeyHandle, SubKeyz, 0, %KEY_QUERY_VALUE, hKey)
n = 0
cnt = 0
DO
    XX = RegEnumValue(hKey, Cnt, Valuez, SIZEOF(Valuez), BYVAL 0, %REG_SZ, sbuffer, SIZEOF(sbuffer))
        Cnt = Cnt + 1
    IF XX = %ERROR_SUCCESS THEN
          value = valuez
          X = INSTR(1, LCASE$(LEFT$(Value, SIZEOF(Valuez))), "\user\")
          IF NOT X = 0 THEN
              Value = MID$(LCASE$(LEFT$(Value, SIZEOF(Valuez))), X+6, LEN(Value))
              CONTROL SET TEXT hdlg, %IDC_Hives, "luft... " & Value
              X = DoesFileExist(pfad & "\" & value)
              IF x = %true THEN
                    X = RemoveFile(pfad & "\" & value)
              END IF
              n = n + 10
              X = BackupReg("HKEY_USERS\" & value, pfad & "\" & value)
              LOCAL devz AS ASCIIZ * 256
              LOCAL dev AS STRING
              LOCAL tpz AS ASCIIZ * 256
              LOCAL tp AS STRING
              LOCAL c AS LONG
              LOCAL d AS LONG
              LOCAL ssbuffer AS STRING
              ssbuffer = sbuffer
              d = 0

              FOR c = 97 TO 122
                  dev = CHR$(c) & ":"
                  devz = dev
                  x = QueryDosDevice(devz, tpz, 256)
                  tp = tpz
                  d = INSTR(1, ssbuffer, tp)
                  IF NOT d = 0 THEN
                      REPLACE tp WITH dev IN ssbuffer
                      PRINT #1, "copy " CHR$(34) & pfad & "\" & value & CHR$(34) & " " & CHR$(34) & ssbuffer & CHR$(34)
                  END IF
              NEXT
              X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 40+n)
          END IF
    END IF
LOOP WHILE XX = %ERROR_SUCCESS
CLOSE #1

CONTROL SET TEXT hdlg, %IDC_Hives, ""
X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 0)

CONTROL ENABLE hDlg, %IDC_Save
CONTROL ENABLE hDlg, %IDC_Restore
CONTROL ENABLE hDlg, %IDC_Quit
CONTROL ENABLE hDlg, %IDC_Browse

END FUNCTION
'--------------------------------------------------------------------------------
'   **  Funktion zur Aufzhlung und Wiederherstellung aller Registry-Hives **
'--------------------------------------------------------------------------------
FUNCTION ResEnumKeys(hdlg AS LONG) AS LONG
LOCAL pfad AS STRING
LOCAL x AS LONG
LOCAL wdconf AS STRING
LOCAL hkey AS LONG
LOCAL hkey1 AS LONG
LOCAL cnt AS LONG
LOCAL XX AS LONG
LOCAL n AS LONG
LOCAL Value AS STRING
LOCAL Valuez AS ASCIIZ * 256
LOCAL Subkeyz AS ASCIIZ * 256
LOCAL Subkey AS STRING
LOCAL sbuffer AS ASCIIZ * 256
LOCAL autost AS STRING
LOCAL autostz AS ASCIIZ * 256

wdconf = ENVIRON$("systemroot") & "\System32\config"
X = RegOpenKeyEx(%HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders", 0&, %KEY_READ, hKey1)
X = RegQueryValueEx(hKey1, "Startup", 0, 1, autostz, SIZEOF(autostz))
X = RegCloseKey(hKey1)
autost = autostz
IF autost = "" THEN
    autost = ENVIRON$("userprofile") & "\Startmen\Programme\Autostart"
ELSEIF NOT INSTR(1, LCASE$(autost), "%userprofile%") = 0 THEN
    autost = ENVIRON$("userprofile") & MID$(autost, 14, LEN(autost))
END IF

x = DoesFileExist(wdconf)
IF X = %false THEN
    MKDIR wdconf
ELSE
    KILL wdconf & "\*"
END IF

CONTROL DISABLE hDlg, %IDC_Save
CONTROL DISABLE hDlg, %IDC_Restore
CONTROL DISABLE hDlg, %IDC_Quit
CONTROL DISABLE hDlg, %IDC_Browse

OPEN autost & "\dellog.bat" FOR OUTPUT AS #1

CONTROL GET TEXT hDlg, %IDC_Pfad TO pfad
SampleProgress hDlg, %IDC_MSCTLS_PROGRESS32_1, 1

CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SOFTWARE"
X=DoesFileExist(pfad & "\SOFTWARE")
IF x = %true THEN
    FILECOPY pfad & "\SOFTWARE", wdconf & "\SOFTWARE.TMP"
    PRINT #1, "attrib -r -s -h " & CHR$(34) & wdconf & "\SOFTWARE.tmp.log" & CHR$(34)
    PRINT #1, "del " & CHR$(34) & wdconf & "\SOFTWARE.tmp.log" & CHR$(34)
    CALL RestoreReg("HKEY_LOCAL_MACHINE\SOFTWARE", "SOFTWARE.tmp", "SOFTWARE.bak") TO X
    X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 10)
END IF

CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SYSTEM"
X=DoesFileExist(pfad &"\SYSTEM")
IF x = %true THEN
    FILECOPY pfad & "\SYSTEM", wdconf & "\SYSTEM.tmp"
    PRINT #1, "attrib -r -s -h " & CHR$(34) & wdconf & "\SYSTEM.tmp.log" & CHR$(34)
    PRINT #1, "del " & CHR$(34) & wdconf & "\SYSTEM.tmp.log" & CHR$(34)
    CALL RestoreReg("HKEY_LOCAL_MACHINE\SYSTEM", "SYSTEM.tmp", "SYSTEM.bak") TO X
    X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 20)
END IF


CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SECURITY"
X=DoesFileExist(pfad &"\SECURITY")
IF x = %true THEN
    FILECOPY pfad & "\SECURITY", wdconf & "\SECURITY.tmp"
    PRINT #1, "attrib -r -s -h " & CHR$(34) & wdconf & "\SECURITY.tmp.log" & CHR$(34)
    PRINT #1, "del " & CHR$(34) & wdconf & "\SECURITY.tmp.log" & CHR$(34)
    CALL RestoreReg("HKEY_LOCAL_MACHINE\SECURITY", "SECURITY.tmp", "SECURITY.bak") TO X
    X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 30)
END IF


CONTROL SET TEXT hdlg, %IDC_Hives, "luft... SAM"
X=DoesFileExist(pfad &"\SAM")
IF x = %true THEN
    FILECOPY pfad & "\SAM", wdconf & "\SAM.tmp"
    PRINT #1, "attrib -r -s -h " & CHR$(34) & wdconf & "\SAM.tmp.log" & CHR$(34)
    PRINT #1, "del " & CHR$(34) & wdconf & "\SAM.tmp.log" & CHR$(34)
    CALL RestoreReg("HKEY_LOCAL_MACHINE\SAM", "SAM.tmp", "SAM.bak") TO X
    X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 40)
END IF

SubKey = "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\hivelist"
X = ParseKey(SubKey, MainKeyHandle)
SubKeyz=SubKey
X = RegOpenKeyEx(MainKeyHandle, SubKeyz, 0, %KEY_QUERY_VALUE, hKey)
n = 0
cnt = 0
DO
    XX = RegEnumValue(hKey, Cnt, Valuez, SIZEOF(Valuez), BYVAL 0, %REG_SZ, sbuffer, SIZEOF(sbuffer))
        Cnt = Cnt + 1
    IF XX = %ERROR_SUCCESS THEN
          value = valuez
          X = INSTR(1, LCASE$(LEFT$(Value, SIZEOF(Valuez))), "\user\")
          IF NOT X = 0 THEN
              Value = MID$(LCASE$(LEFT$(Value, SIZEOF(Valuez))), X+6, LEN(Value))
              CONTROL SET TEXT hdlg, %IDC_Hives, "luft... " & Value
              X = DoesFileExist(pfad & "\" & value)
              IF x = %true THEN
                    n = n + 10
                    FILECOPY pfad & "\" & value, wdconf & "\" & value & ".tmp"
                    PRINT #1, "attrib -r -s -h " & CHR$(34) & wdconf & "\" & value & ".tmp.log" & CHR$(34)
                    PRINT #1, "del " & CHR$(34) & wdconf & "\" & value & ".tmp.log" & CHR$(34)
                    CALL RestoreReg("HKEY_USERS\" & Value, value & ".tmp", value & ".bak") TO X
                    X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 40 + n)
              END IF
          END IF
    END IF
LOOP WHILE XX = %ERROR_SUCCESS

autost = LCASE$(autost)
REPLACE "" WITH CHR$(129) IN autost

PRINT #1, "cd /d " & CHR$(34) & autost & CHR$(34)
PRINT #1, "del /f dellog.bat"
CLOSE #1

CONTROL SET TEXT hdlg, %IDC_Hives, ""
X = SampleProgress(hDlg, %IDC_MSCTLS_PROGRESS32_1, 0)

CONTROL ENABLE hDlg, %IDC_Save
CONTROL ENABLE hDlg, %IDC_Restore
CONTROL ENABLE hDlg, %IDC_Quit
CONTROL ENABLE hDlg, %IDC_Browse

END FUNCTION

'--------------------------------------------------------------------------------
'BrowseForFolder Funktion
'--------------------------------------------------------------------------------
 FUNCTION GetFolderDlg(hdlg AS LONG) AS STRING
    LOCAL browseTyp AS BROWSEINFO
    LOCAL rval AS LONG
    LOCAL a AS ASCIIZ * 260
    LOCAL x AS LONG

    browseTyp.hwndOwner = GetActiveWindow()
    browseTyp.lpszTitle = lstrcat("Bitte whlen Sie ein Verzeichnis aus." + CHR$(0), CHR$(0))
    browseTyp.ulFlags = %BIF_RETURNONLYFSDIRS
    browseTyp.pszDisplayName = VARPTR(a)

    rval = SHBrowseForFolder(browseTyp)

    IF rval <> 0 THEN
       SHGetPathFromIDList BYVAL rval, a
       CoTaskMemFree rval
       FUNCTION = TRIM$(a)
    ELSE
       FUNCTION = CURDIR$
    END IF
    X=DoesFileExist(TRIM$(a) & "\SYSTEM") AND DoesFileExist(TRIM$(a) & "\SOFTWARE") AND DoesFileExist(TRIM$(a) &"\SAM")
    IF x = %true THEN
         CONTROL ENABLE hDlg, %IDC_Restore
    ELSE
        CONTROL DISABLE hDlg, %IDC_Restore
    END IF
END FUNCTION
'--------------------------------------------------------------------------------
'   ** CallBacks **
'--------------------------------------------------------------------------------
CALLBACK FUNCTION ShowDIALOG1Proc()
    LOCAL ret AS LONG
    LOCAL datesub AS LONG
    LOCAL pfad AS STRING
    LOCAL gf AS STRING

    SELECT CASE CBMSG
        CASE %WM_COMMAND
            SELECT CASE CBCTL
                CASE %IDC_MSCTLS_PROGRESS32_1
                CASE %IDC_Hives
                CASE %IDC_Pfad
                CASE %IDC_Browse
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        CONTROL GET CHECK CBHNDL, %IDC_Date TO datesub
                        IF datesub = 1 THEN
                            gf =  GetFolderDlg(CBHNDL)
                            pfad = gf & "\" & DATE$
                            REPLACE "\\" WITH "\" IN pfad
                            CONTROL SET TEXT CBHNDL, %IDC_Pfad, pfad
                        ELSE
                            gf =  GetFolderDlg(CBHNDL)
                            CONTROL SET TEXT CBHNDL, %IDC_Pfad, gf
                        END IF
                    END IF
                CASE %IDC_Save
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        BakEnumKeys(CBHNDL)
                        CONTROL SET TEXT CBHNDL, %IDC_Hives, "Sicherung fertig"
                    END IF
                CASE %IDC_Restore
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                        ret = MSGBOX("Mchten Sie die Registry wirklich wiederherstellen?", %MB_YESNO + %MB_ICONQUESTION, "Registry wiederherstellen")
                        IF ret = %IDYES THEN
                            ResEnumKeys(CBHNDL)
                            CONTROL SET TEXT CBHNDL, %IDC_Hives, "Wiederherstellung fertig"
                            ret = MSGBOX("Die Wiederherstellung ist abgeschlossen, soll der Rechner jetzt neu gestartet werden?", %MB_ICONINFORMATION + %MB_YESNO, "Fertig")
                            IF ret = %IDYES THEN
                                ret = EnableShutdownPriv
                                ret = ExitWindowsEx(%EWX_REBOOT + %EWX_FORCE, 0) 'System-Neustart erzwingen
                            ELSE
                                EXIT FUNCTION
                            END IF
                        END IF
                    END IF
                CASE %IDC_Quit
                    IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                         DIALOG END CBHNDL, 0
                    END IF
                CASE %IDC_Date
                    CONTROL GET TEXT CBHNDL, %IDC_Pfad TO pfad
                    CONTROL GET CHECK CBHNDL, %IDC_Date TO datesub
                    IF datesub = 1 THEN
                        pfad = pfad & "\" & DATE$
                        REPLACE "\\" WITH "\" IN pfad
                        CONTROL SET TEXT CBHNDL, %IDC_Pfad, pfad
                    ELSE
                        IF NOT INSTR(1, pfad, DATE$) = 0 THEN
                            pfad = MID$(pfad, 1, INSTR(1, pfad, DATE$)-2)
                            IF LEN(pfad) = 2 THEN Pfad = Pfad & "\"
                            CONTROL SET TEXT CBHNDL, %IDC_Pfad, pfad
                        ELSE
                            CONTROL SET TEXT CBHNDL, %IDC_Pfad, pfad
                        END IF
                    END IF
                    ret=DoesFileExist(pfad & "\SYSTEM") AND DoesFileExist(pfad & "\SOFTWARE") AND DoesFileExist(pfad &"\SAM")
                    IF ret = %true THEN
                        CONTROL ENABLE CBHNDL, %IDC_Restore
                    ELSE
                        CONTROL DISABLE CBHNDL, %IDC_Restore
                    END IF
            END SELECT
    END SELECT

END FUNCTION
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Fortschrittsbalken **
'--------------------------------------------------------------------------------
FUNCTION SampleProgress(BYVAL hDlg AS DWORD, BYVAL lID AS LONG, n AS LONG) AS LONG
    CONTROL SEND hDlg, lID, %PBM_SETRANGE, 0,  MAKDWD(0, 100)
    CONTROL SEND hDlg, lID, %PBM_SETPOS,   n, 0
END FUNCTION
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
'   ** Dialog **
'--------------------------------------------------------------------------------
FUNCTION ShowDIALOG1(BYVAL hParent AS DWORD) AS LONG
    LOCAL lRslt AS LONG
#PBFORMS Begin Dialog %IDD_DIALOG1->->
    LOCAL hDlg AS DWORD

    DIALOG NEW hParent, "PC-Welt: Registry Sicherung", 52, 64, 366, 122, TO hDlg
    CONTROL ADD IMAGEX, hDlg, %IDC_IMAGEX1, "#" + FORMAT$(%IDR_IMGFILE1), 0, 0, 366, 40
    CONTROL ADD LABEL, hDlg, %IDC_Hives, "", 5, 45, 350, 10
    CONTROL ADD "msctls_progress32", hDlg, %IDC_MSCTLS_PROGRESS32_1, "", 5, 55, 355, 10, %WS_CHILD OR %WS_VISIBLE
    CONTROL ADD LABEL, hDlg, %IDC_ZP, "Backup-/Wiederherstellungsordner:", 5, 75, 350, 10
    CONTROL ADD TEXTBOX, hDlg, %IDC_Pfad, CURDIR$, 5, 87, 310, 10, %ES_READONLY OR %WS_BORDER
    CONTROL ADD BUTTON, hDlg, %IDC_Browse, ">>", 320, 87, 40, 10
    CONTROL ADD BUTTON, hDlg, %IDC_Save, "Sichern", 85, 102, 75, 15
    CONTROL ADD BUTTON, hDlg, %IDC_Restore, "Wiederherstellen", 5, 102, 75, 15
    CONTROL ADD CHECKBOX, hDlg, %IDC_Date, "Ordner mit aktuellem Datum anlegen", 165, 102, 145, 15
    CONTROL ADD BUTTON, hDlg, %IDC_Quit, "Quit", 320, 102, 40, 15

#PBFORMS End Dialog
    lRslt=DoesFileExist(CURDIR$ & "\SYSTEM") AND DoesFileExist(CURDIR$ & "\SOFTWARE") AND DoesFileExist(CURDIR$ &"\SAM")
    IF lRslt = %true THEN
         CONTROL ENABLE hDlg, %IDC_Restore
    ELSE
        CONTROL DISABLE hDlg, %IDC_Restore
    END IF

    SampleProgress hDlg, %IDC_MSCTLS_PROGRESS32_1, 0

    DIALOG SHOW MODAL hDlg, CALL ShowDIALOG1Proc TO lRslt

    FUNCTION = lRslt
END FUNCTION
'--------------------------------------------------------------------------------
